/////////////////////////////////////////////////////////////////////////////
// Name:        Misc.cpp
// Purpose:    Misc stuff
// Part of:       4Pane
// Author:       David Hart
// Copyright:   (c) 2007 David Hart
// Licence:     wxWindows licence
/////////////////////////////////////////////////////////////////////////////
#ifndef MISCH
#define MISCH

#include "wx/wx.h"
#include "wx/dirctrl.h"

//		A class that displays a plain message, rather like wxMessageBox, but without buttons.  It autocloses after a user-defined no of seconds

class BriefMessageBox;

class MyBriefMessageTimer	:	 public wxTimer	// Used by BriefMessageBox.  Notify() kills the BriefMessageBox when the timer 'fires'
{
public:
void Setup( wxDialog* ptrtobox ){ p_box = ptrtobox; }
protected:
void Notify(){ p_box->EndModal( wxID_CANCEL ); }

wxDialog* p_box;
};

class BriefMessageBox	:	public wxDialog			// Displays a message dialog for a defined time only
{
public:
BriefMessageBox( wxString Message, double secondsdisplayed = -1, wxString Caption = wxEmptyString );
protected:
MyBriefMessageTimer BriefTimer;
};

enum	// for FileDirDlg
{
    FD_MULTIPLE = 0x0001,
    FD_SHOWHIDDEN = 0x0002,
    FD_RETURN_FILESONLY = 0x0004
};

class FileDirDlg	:	public wxDialog			// A dialog that can select both files and dirs
{
public:
FileDirDlg(){}
FileDirDlg( wxWindow* parent, int style=FD_MULTIPLE | FD_SHOWHIDDEN, wxString defaultpath=wxEmptyString, wxString label =_( "File and Dir Select Dialog" ) );
wxString GetFilepath(){ return filepath; }							// Get a single filepath
void GetPaths( wxArrayString& filepaths );						// Get multiple filepaths

protected:
void OnSelChanged(wxTreeEvent& WXUNUSED(event));
void OnHome(wxCommandEvent& WXUNUSED(event));
void OnHidden(wxCommandEvent& event);
void OnEraseBackground( wxEraseEvent& event );

wxString filepath;
wxGenericDirCtrl* GDC;
wxTextCtrl* Text;
int SHCUT_HOME;
bool filesonly;

DECLARE_DYNAMIC_CLASS(FileDirDlg)
};

#endif    //MISCH




